-- create table from value repeated
function table.rep(s,n)
    local t,i = {}
    for i = 1,n do t[i] = s end
    return t
end

-- get subset of table
function table.sub(t,a,b)
    local o,i = {}
    for i = a,b do o[i-a+1] = t[i] end
    return o
end

-- range function
function table.range(a,b,d)
    d = d or 1
    local t,i = {}
    local n = math.abs((b-a)/d)+1
    for i = 1,n do t[i] = a+d*(i-1) end
    return t
end

-- oneline table index
function table.index(t,i)
    return t[i]
end

-- range for input areas
function table.iarange(n)
    return table.range(0,fn.h*(n-1),fn.h)
end

-- print table
function table.print(t)
    local s = ''
    for i = 1,(#t-1) do
        s = s..t[i]..', '
    end
    s = s..t[#t]
    print(s)
end

-- adds alpha to color table if no alpha is there
function table.addcola(t)
    if #t == 3 then t[4] = 255 end
    return t
end

-- round number
function math.round(num, idp)
    local mult = 10^(idp or 0)
    return math.floor(num * mult + 0.5) / mult
end

boolean = {}
-- boolean map
function boolean.map(c)
    if c then return 2 else return 1 end
end

-- finds nth instance of pattern
function string.findnth(s,p,n)
    local a,b,i = 1
    for i = 1,n do
        a,b = s:find(p,a)
        if a == nil then return a end
        a = b+1
    end
    a = a-p:len()
    return a
end

-- removes formatting commands from string
function string.unformat(s)
    s = s:gsub('|n','')
    s = s:gsub('|,','')
    s = s:gsub('|:','')
    s = s:gsub('|!','')
    s = s:gsub('|c%x%x%x%x%x%x%x%x','')
    return s
end